#include "SWM221.h"

void SerialInit(void);

int main(void)
{
    // 巢飬8ֽ
    uint8_t tx_data[8] = {1, 2, 3, 4, 5, 6, 7, 8};
    CAN_InitStructure CAN_initStruct;  // CANʼṹ
    CAN_RXMessage CAN_msg;            // CANϢṹ
    
    SystemInit();    // ϵͳʱӡڴ桢жϵȳʼ
    SerialInit();    // ͨųʼںݴӡ
    
		GPIO_Init(GPIOA, PIN3, 1, 0, 1, 0);			//MCUʹ
    // ʼPORTB78ΪCAN0RX/TXܣ帴ùοоƬֲᣩ
    // ˿, ź, ù, /ʹܣ1-ʹܣ0-ã
    PORT_Init(PORTB, PIN7, PORTB_PIN7_CAN0_RX, 1);  // CAN0
    PORT_Init(PORTB, PIN8, PORTB_PIN8_CAN0_TX, 0);  // CAN0
    
		
    // CANʼ
    CAN_initStruct.Mode = CAN_MODE_SELFTEST;     // Բģʽ̽TXRX
    CAN_initStruct.CAN_bs1 = CAN_BS1_5tq;        // λʱ1ռ5ʱ䵥λ
    CAN_initStruct.CAN_bs2 = CAN_BS2_4tq;        // λʱ2ռ4ʱ䵥λ
    CAN_initStruct.CAN_sjw = CAN_SJW_2tq;        // ͬת2ʱ䵥λ
    CAN_initStruct.Baudrate = 50000;             // 50kbps
    CAN_initStruct.RXNotEmptyIEn = 0;            // ýж
    CAN_initStruct.ArbitrLostIEn = 0;            // ٲöʧж
    CAN_initStruct.ErrPassiveIEn = 0;            // ô󱻶ж
    CAN_Init(CAN0, &CAN_initStruct);             // ӦóʼCAN0
    
    // CAN32λģʽ
    // CANģ, , ʶID, 루0x1FFFFFFEʾIDλ仯
    // ܣչIDΪ0x001221220x00122123֡
    CAN_SetFilter32b(CAN0, CAN_FILTER_1, 0x00122122, 0x1FFFFFFE);
    
    // CAN16λģʽ
    // CANģ, , ID1, 1, ID2, 2
    // ܣձ׼IDΪ0x1220x1230x7FE0x1010x7FF֡
    CAN_SetFilter16b(CAN0, CAN_FILTER_2, 0x122, 0x7FE, 0x101, 0x7FF);
    
    CAN_Open(CAN0);  // CAN0
    
    // ͱ׼֡ID: 0x122, ݳ8ֽ, Զش
    CAN_Transmit(CAN0, CAN_FRAME_STD, 0x122, tx_data, 8, 1);
    while(CAN_TXComplete(CAN0) == 0) __NOP();  // ȴ
    
    // չ֡ID: 0x122122, ݳ8ֽ, Զش
    CAN_Transmit(CAN0, CAN_FRAME_EXT, 0x122122, tx_data, 8, 1);
    while(CAN_TXComplete(CAN0) == 0) __NOP();  // ȴ
    
    // ѭȡнյCANϢͨڴӡ
    while(CAN_RXDataAvailable(CAN0))
    {
        CAN_Receive(CAN0, &CAN_msg);  // ӻȡϢ
        
        // ӡ֡ͺID
        printf("\r\nReceive %s %08X: ", 
               CAN_msg.format == CAN_FRAME_STD ? "STD" : "EXT", 
               CAN_msg.id);
        
        // ӡݣʮƸʽ
        for(int i = 0; i < CAN_msg.size; i++) 
            printf("%02X, ", CAN_msg.data[i]);
    }
    
    // ѭֳУ
    while(1==1)
    {
    }
}


/*
 * SerialInit
 * ܣʼUART0ͨ
 * 
 * ֵ
 * עPA.0ΪUART0_RXPA.1ΪUART0_TX
 *     576008λݣУ飬1λֹͣλ
 *     FIFOֵշ3ֽʱжδʹܣ
 *     ճʱʱ10λ嵥λοӲֲᣩʱжδʹ
 */
void SerialInit(void)
{
    UART_InitStructure UART_initStruct;
    
    // PA0ΪUART0չܣ1
    PORT_Init(PORTA, PIN0, PORTA_PIN0_UART0_RX, 1); 
    // PA1ΪUART0͹ܣ0
    PORT_Init(PORTA, PIN1, PORTA_PIN1_UART0_TX, 0); 
    
    // ʼUARTýṹ
    UART_initStruct.Baudrate = 57600;       // 57600bps
    UART_initStruct.DataBits = UART_DATA_8BIT; // 8λλ
    UART_initStruct.Parity = UART_PARITY_NONE; // У
    UART_initStruct.StopBits = UART_STOP_1BIT; // 1λֹͣλ
    UART_initStruct.RXThreshold = 3;       // FIFOֵ3ֽ
    UART_initStruct.RXThresholdIEn = 0;    // ýֵж
    UART_initStruct.TXThreshold = 3;       // FIFOֵ3ֽ
    UART_initStruct.TXThresholdIEn = 0;    // ÷ֵж
    UART_initStruct.TimeoutTime = 10;      // ճʱʱ䣨λӲ
    UART_initStruct.TimeoutIEn = 0;        // óʱж
    
    // ӦòUART0
    UART_Init(UART0, &UART_initStruct);    // ʼUART0
    UART_Open(UART0);                      // UART0ͨ
}

/*********************************************************************************************
* : fputc()
* ˵: printf()ʹô˺ʵʵĴڴӡ
*     : int ch		Ҫӡַ
*			FILE *f		ļ
*     : 
* ע: 
**********************************************************************************************/
int fputc(int ch, FILE *f)
{
	UART_WriteByte(UART0, ch);
	
	while(UART_IsTXBusy(UART0));
 	
	return ch;
}
